/**
 * Einsatz von Unions
 * Author: Martin Vogel, Dozent HSLU Luzern
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/**
 * union, welche Zahl als Float oder 4 Byte aufnimmt
 */
union uZahl_union
{
	long int liZahl;

	struct
	{
		unsigned char Byte3;
		unsigned char Byte2;
		unsigned char Byte1;
		unsigned char Byte0;
	}sByte;

	struct
	{
		unsigned int iByte3 : 8;
		unsigned int iByte2 : 8;
		unsigned int iByte1 : 8;
		unsigned int iByte0 : 8;
	}iByte;

	float fZahl;
};

/**
 * uebergebener String umkehren
 */
void reverse(char *str)
{
	int i = 0, j = strlen(str) - 1;
	char c;
	while (i < j)
	{
		c = str[i];
		str[i] = str[j];
		str[j] = c;
		i++;
		j--;
	}
}

/**
 * Gibt einen long int in binre Zeichenkette von 1 und 0 aus
 */
void bin_print(long int wert)
{
	unsigned int z;
	char s[100];
	int i;
	z = (unsigned int)wert;
	i = 0;
	while (z)
	{
		s[i] = (z & 0x01) ? '1' : '0';
		z >>= 1;
		i++;
	}
	s[i] = '\0'; // String Ende
	reverse(s); // String umkehren
	printf("\nDie Zahl in binaer: %s\n", s);
}

/**
 * Umwandlung von 4 Byte nach Float oder umgekehrt. Funktionsweise mittels UNION
 */
int main(int argc, char** argv)
{
	char c;
	union uZahl_union uZahl; // Definition union
	do
	{
		printf("\n");
		printf("B --> Eingabe als 4 Bytes\n");
		printf("F --> Eingabe als Float-Wert\n");
		printf("Q --> Quit\n");
		printf("\n");

		// Solange einlesen bis Zahl oder Buchstabe
		while (!isalnum(c = getchar()));
		c = toupper(c);

		switch (c)
		{
			case 'B':
				printf("Gegen Sie die 4 Bytes in Hex ein:");
				scanf("%x", &uZahl.liZahl);
				printf("\nDie Zahl in Hex: %X %X %X %X\n", uZahl.iByte.iByte0, uZahl.iByte.iByte1, uZahl.iByte.iByte2, uZahl.iByte.iByte3);
				printf("\nDie Zahl in Float: %e\n", uZahl.fZahl);
				bin_print(uZahl.liZahl);
				break;
			case 'F':
				printf("Geben Sie die Zahl als Float-Wert ein: ");
				scanf("%f", &(uZahl.fZahl));
				printf("\nDie Zahl in Float: %e\n", uZahl.fZahl);
				printf("\nDie Zahl in Hex: %X %X %X %X\n", uZahl.iByte.iByte0, uZahl.iByte.iByte1, uZahl.iByte.iByte2, uZahl.iByte.iByte3);
				bin_print(uZahl.liZahl);
				break;
			default:
				break;
		}
	} while (c != 'Q');
	return (EXIT_SUCCESS);
}